
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inspection_resultsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inspection_results = await db.inspection_results.create(
            {
                id: data.id || undefined,
        
        measured_value: data.measured_value
        ||
        null
            ,
            
        attribute_value: data.attribute_value
        ||
        null
            ,
            
        judgement: data.judgement
        ||
        null
            ,
            
        comments: data.comments
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inspection_results.setInspection( data.inspection || null, {
            transaction,
        });
        
        await inspection_results.setCharacteristic( data.characteristic || null, {
            transaction,
        });
        

        

        

        return inspection_results;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inspection_resultsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                measured_value: item.measured_value
            ||
            null
            ,
            
                attribute_value: item.attribute_value
            ||
            null
            ,
            
                judgement: item.judgement
            ||
            null
            ,
            
                comments: item.comments
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inspection_results = await db.inspection_results.bulkCreate(inspection_resultsData, { transaction });

        // For each item created, replace relation files
        

        return inspection_results;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const inspection_results = await db.inspection_results.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.measured_value !== undefined) updatePayload.measured_value = data.measured_value;
        
        
        if (data.attribute_value !== undefined) updatePayload.attribute_value = data.attribute_value;
        
        
        if (data.judgement !== undefined) updatePayload.judgement = data.judgement;
        
        
        if (data.comments !== undefined) updatePayload.comments = data.comments;
        
        
        updatePayload.updatedById = currentUser.id;

        await inspection_results.update(updatePayload, {transaction});

        
        
        if (data.inspection !== undefined) {
            await inspection_results.setInspection(
              
              data.inspection,
              
              { transaction }
            );
        }
        
        if (data.characteristic !== undefined) {
            await inspection_results.setCharacteristic(
              
              data.characteristic,
              
              { transaction }
            );
        }
        

        
        

        

        return inspection_results;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inspection_results = await db.inspection_results.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inspection_results) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inspection_results) {
                await record.destroy({transaction});
            }
        });


        return inspection_results;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inspection_results = await db.inspection_results.findByPk(id, options);

        await inspection_results.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inspection_results.destroy({
            transaction
        });

        return inspection_results;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inspection_results = await db.inspection_results.findOne(
            { where },
            { transaction },
        );

        if (!inspection_results) {
            return inspection_results;
        }

        const output = inspection_results.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inspection = await inspection_results.getInspection({
            transaction
        });
        
        
        output.characteristic = await inspection_results.getCharacteristic({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.inspections,
        as: 'inspection',
        
        where: filter.inspection ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspection.split('|').map(term => Utils.uuid(term)) } },
            {
              inspection_number: {
                [Op.or]: filter.inspection.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.inspection_characteristics,
        as: 'characteristic',
        
        where: filter.characteristic ? {
          [Op.or]: [
            { id: { [Op.in]: filter.characteristic.split('|').map(term => Utils.uuid(term)) } },
            {
              characteristic_name: {
                [Op.or]: filter.characteristic.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.comments) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inspection_results',
                        'comments',
                        filter.comments,
                    ),
                };
            }
            

            
            

            
            if (filter.measured_valueRange) {
                const [start, end] = filter.measured_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    measured_value: {
                    ...where.measured_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    measured_value: {
                    ...where.measured_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.attribute_value) {
                where = {
                    ...where,
                attribute_value: filter.attribute_value,
            };
            }
            
            if (filter.judgement) {
                where = {
                    ...where,
                judgement: filter.judgement,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inspection_results.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inspection_results',
                        'comments',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inspection_results.findAll({
            attributes: [ 'id', 'comments' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['comments', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.comments,
        }));
    }

    
};

